#!/bin/sh

echo "Flushing log files"

cd /var/log

files=`ls *.log messages` 
backup_dir="/hiwrite/logs"
trim_size=1500000

mkdir -p $backup_dir

for file in $files
	do
	size=`ls -l $file | awk '{print $5}'`
	trim_name=`echo $file | awk '{if(match($0,".log$")==0) {print $0} else
 {print(substr($0,1,length($0)-4))} }'`

	if [ $size -gt 0 ]
			then
			echo "[$trim_name]"

			out_file=$trim_name".1"

			mv $file $out_file
			touch $file

			backup_base="$backup_dir/$trim_name"

			ext="2 1"

			if [ -f $backup_base.1 ]
					then
					size=`ls -l $backup_base.1 | awk '{print $5}'`
					if [ $size -gt $trim_size ]
							then
							echo "Rotate $backup_base.1.gz ($size bytes)"
							
							for num in $ext
								do
								mv -f $backup_base.$num $backup_base.$(($num+1)) 
							done
							
							echo "Moving $out_file.gz to $backup_dir"
							mv $out_file $backup_dir
					else
							echo "appending to existing $backup_base.1.gz"
							cat $out_file >> $backup_base.1
							rm -f $out_file
					fi
			else
					echo "New backup file: moving $out_file.gz to $backup_dir"
					mv $out_file $backup_dir
			fi
	else
			echo "[$trim_name] zero-sized"
	fi
done
