#!/bin/sh

# This script is run from the temporary directory that the upgrade is
# extracted to
echo "Running full upgrade post install"

#-- Remove any crc files ----------
rm -rf /hiwrite/files.crc

#-- Install new upgrade software --------------------
if [ -d /cathexis/upgrade.new ]
then
		# This apparently unnecessary work is done to ensure that
		# the upgrade software is always available
		echo "Upgrading upgrade software"

		if [ ! -x /cathexis/upgrade.new/upgrade.sh ]
		then
				echo "Upgrade doesn't contain upgrade.sh"
				exit 1
		fi

		if [ ! -x /cathexis/upgrade.new/cat_upgrade ]
		then
				echo "Upgrade doesn't contain cat_upgrade"
				exit 1
		fi

		LINKRENAME=`readlink -f utils/renamelink`
		PWD=`pwd`
		cd /cathexis

		ORIGINAL=`readlink upgrade`

		if [ $ORIGINAL != upgrade.new ]
		then
				# Link in the new upgrade
				ln -sfn upgrade.new upgrade.temp_link
				$LINKRENAME upgrade.temp_link upgrade
				
				# Move the old upgrade to a temp path
				OLD_DIR=`mktemp -d /cathexis/upgrade.temp.XXXXXX`
				rmdir $OLD_DIR
				mv $ORIGINAL $OLD_DIR
				ln -sfn $OLD_DIR upgrade.temp_link
				$LINKRENAME upgrade.temp_link upgrade
				
				# Make the new upgrade current
				mv upgrade.new upgrade.current
				ln -sfn upgrade.current upgrade.temp_link
				$LINKRENAME upgrade.temp_link upgrade

				# Remove the old upgrade (this doesn't complete properly on NFS)
				rm -fr $OLD_DIR
		else
				# The current is upgrade.new. This can happen if the system loses
				# power mid-upgrade. In this case rename the directory and update
				# the link. This is not atomic.
				echo "Fixing aborted upgrade"
				mv upgrade.new upgrade.current
				ln -sfn upgrade.current upgrade
		fi

		cd $PWD
else 
		echo "No upgrade software!"
fi

exit 0
